package api.screenshot

import android.app.Activity
import android.content.Context
import android.util.Log
import android.view.View
import api.bean.API_TX_NativeBean
import api.bean.GDT_NativeBean
import com.qq.e.ads.banner.ADSize
import com.qq.e.ads.banner.AbstractBannerADListener
import com.qq.e.ads.banner.BannerView
import com.qq.e.ads.nativ.NativeAD
import com.qq.e.ads.nativ.NativeADDataRef
import com.qq.e.comm.util.AdError
import java.util.*

class TX_Screenshot : Screenshot_API_TX() {
    private var banner: BannerView? = null
    private var native: NativeAD? = null
    override fun loadNative(context: Context, LoadCount: Int, GDTAPPID: String?, NativePosID: String?, callBack: LoadNativeCallBack?) {
        native = NativeAD(context.applicationContext, GDTAPPID, NativePosID, object : NativeAD.NativeAdListener {
            override fun onADStatusChanged(p0: NativeADDataRef?) {
                Log.i("TX", "NativeonADStatusChanged")
                if (p0 != null) {
                    val ref = GDT_NativeBean(p0)
                    callBack?.onNativeStatusChanged(ref)
                }
            }

            override fun onADError(p0: NativeADDataRef?, p1: AdError?) {
                Log.e("TX", "NativeonError")
                callBack?.onNativeError(p1?.errorCode.toString(), p1?.errorMsg)
            }

            override fun onADLoaded(p0: MutableList<NativeADDataRef>?) {
                Log.i("TX", "NativeonLoaded")
                if (p0 != null && !p0.isEmpty()) {
                    val nativeGDTDataRefApplyList = ArrayList<API_TX_NativeBean>()
                    for (bean in p0) {
                        val ref = GDT_NativeBean(bean)
                        nativeGDTDataRefApplyList.add(ref)
                    }
                    callBack?.onNativeSuccessed(nativeGDTDataRefApplyList)
                }
            }

            override fun onNoAD(p0: AdError?) {
                Log.e("TX", "onNoNativeon")
                callBack?.onNoNative()
            }
        })
        native?.loadAD(LoadCount)
    }

    override fun loadBanner(context: Activity?, GDTAPPID: String?, BannerID: String?, callBack: LoadBannerCallBack?): View {
        banner = BannerView(context, ADSize.BANNER, GDTAPPID, BannerID)
        //设置广告轮播时间，为0或30~120之间的数字，单位为s,0标识不自动轮播
        banner!!.setRefresh(0)
        banner!!.setADListener(object : AbstractBannerADListener() {
            override fun onNoAD(error: AdError) {
                Log.e("TX", "BannerNoAD，eCode=" + error.errorCode)
                callBack?.onNoBanner(error.errorCode.toString(), error.errorMsg)
            }

            override fun onADClicked() {
                super.onADClicked()
                Log.i("TX", "onBannerClicked")
                callBack?.onBannerClicked()
            }

            override fun onADExposure() {
                super.onADExposure()
                Log.i("TX", "onBannerExposure")
                callBack?.onBannerExposure()
            }

            override fun onADReceiv() {
                Log.i("TX", "onBannerReceiv")
                callBack?.onBannerReceiv()
            }
        })
        /* 发起广告请求，收到广告数据后会展示数据   */
        banner!!.loadAD()
        return banner as BannerView
    }

    override fun bannerDestroy() {
        banner?.destroy()
    }
}
